#
# Scrobble Free - Scrobble to libre.fm and last.fm.
# Copyright (C) 2009 Michael Gratton.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

import gtk


class PrefsDialog(object):


    def __init__(self, ui, scrobblers):
        builder = gtk.Builder()
        builder.add_from_file(ui)

        builder.connect_signals(self)

        self.dialog = builder.get_object('prefs-dialog')

        treeview = builder.get_object('services-treeview')

        renderer = gtk.CellRendererToggle()
        renderer.connect('toggled', self._enabled_toggled_cb)
        #treeview.append_column(gtk.TreeViewColumn('Enabled',
        #                                          renderer, active=0))

        renderer = gtk.CellRendererText()
        treeview.append_column(gtk.TreeViewColumn('Service',
                                                  renderer, text=1))

        renderer = gtk.CellRendererText()
        renderer.connect('edited', self._user_edited_cb)
        renderer.props.editable = True
        treeview.append_column(gtk.TreeViewColumn('User',
                                                  renderer, text=2))

        self.liststore = gtk.ListStore(bool, str, str, object)
        for scrobbler in scrobblers:
            self.liststore.append((scrobbler.enabled,
                                   scrobbler.uri,
                                   scrobbler.user,
                                   scrobbler))

        treeview.set_model(self.liststore)

    def _enabled_toggled_cb(self, renderer, path):
        scrobbler = self.liststore[path][3]
        scrobbler.enabled = not scrobbler.enabled
        self.liststore[path][0] = scrobbler.enabled
        scrobbler.save()

    def _user_edited_cb(self, renderer, path, text):
        self.liststore[path][2] = text
        scrobbler = self.liststore[path][3]
        scrobbler.user = text
        scrobbler.save()

    def _add_cb(self, action):
        pass

    def _remove_cb(self, action):
        pass

    def _dialog_response_cb(self, dialog, repsonse):
        self.dialog.hide()

    def _close_activate_cb(self, button):
        self.dialog.hide()

